# 32/64bit spec-file
#
%define	lib_major 1
%define	lib_name %{name}%{lib_major}

%define build_biarch 0
# Enable bi-arch build on x86-64
%ifarch x86_64
%define build_biarch 1
%endif

Summary:	The zlib compression and decompression library
Name:		zlib
Version:	1.2.8
Release:	%mkrel 5
Group:		System/Libraries
License:	BSD
URL:		http://www.gzip.org/zlib/
Source0:	http://prdownloads.sourceforge.net/libpng/%{name}-%{version}.tar.xz
BuildRequires:	util-linux-ng
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
Requires:	glibc >= 2.20

%description
The zlib compression library provides in-memory compression and
decompression functions, including integrity checks of the uncompressed
data.  This version of the library supports only one compression method
(deflation), but other algorithms may be added later, which will have
the same stream interface.  The zlib library is used by many different
system programs.

%package -n	%{lib_name}
Summary:	The zlib compression and decompression library
Group:		System/Libraries
Obsoletes:	libz, libz1, %{name}, %{_lib}zlib1 = 1.2.7-1 , %{_lib}minizip1 = 1.2.7-1

%define	liberr	%{mklibname %{name}%{lib_major}}
%rename	%{liberr}
Provides:	libz = %{version}-%{release} libz1 = %{version}-%{release} %{name} = %{version}-%{release}

%description -n	%{lib_name}
The zlib compression library provides in-memory compression and
decompression functions, including integrity checks of the uncompressed
data.  This version of the library supports only one compression method
(deflation), but other algorithms may be added later, which will have
the same stream interface.  The zlib library is used by many different
system programs.

%package -n	%{lib_name}-devel
Summary:	Header files and libraries for developing apps which will use zlib
Group:		Development/Libraries
Requires:	%{lib_name} = %{version}-%{release}
Obsoletes:	libz1-devel libz-devel zlib-devel %{_lib}zlib-devel = 1.2.7-1 %{_lib}minizip-devel = 1.2.7-1

%define	deverr	%{mklibname -d %{name}}
%rename	%{deverr}
Provides:	libz-devel = %{version}-%{release} libz1-devel = %{version}-%{release} %{name}-devel = %{version}-%{release}

%description -n	%{lib_name}-devel
The zlib-devel package contains the header files and libraries needed
to develop programs that use the zlib compression and decompression
library.

Install the zlib-devel package if you want to develop applications that
will use the zlib library.

#-------------------------------------------------------------------------

%prep
%setup -q

%build
#(peroyvind): be sure to remove -m64/-m32 flags as they're not overridable
RPM_OPT_FLAGS="`echo $RPM_OPT_FLAGS| sed -e 's/-m.. //g'` -O3"
mkdir objs
cp -a $(ls | grep -v objs) objs/
pushd objs
  CFLAGS="$RPM_OPT_FLAGS" LDFLAGS="%{?ldflags}" \
%if %{build_biarch}
  CC="%{__cc} -m64" \
%endif
  ../configure --shared --prefix=%{_prefix} --libdir=%{_libdir}
  %make
  make test
popd

mkdir objsdietlibc
cp -a $(ls | grep -v objs) objsdietlibc/
pushd objsdietlibc
  CFLAGS="-Os" CC="diet gcc" \
  ./configure --prefix=%{_prefix}
  %make libz.a
popd


%if %{build_biarch}
%ifarch %{sunsparc}
RPM_OPT_FLAGS_32="$RPM_OPT_FLAGS"
%else
RPM_OPT_FLAGS_32=`linux32 rpm --eval %%optflags|sed -e 's#i586#pentium4#g'`
%endif
mkdir objs32
cp -a $(ls | grep -v objs) objs32/
pushd objs32
  CFLAGS="$RPM_OPT_FLAGS_32" LDFLAGS="%{?ldflags}" CC="%{__cc} -m32" \
  ../configure --shared --prefix=%{_prefix}
  %make
  make test
popd
%endif

pushd contrib/minizip
autoreconf --install
%configure --enable-static=no
%make
popd


%install
rm -rf %{buildroot}

install -d %{buildroot}/%{_prefix}
install -d %{buildroot}/%{_libdir}

make install -C objs prefix=%{buildroot}%{_prefix} libdir=%{buildroot}%{_libdir}
%if %{build_biarch}
make install-libs -C objs32 prefix=%{buildroot}%{_prefix}
%endif

install -d %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/*.so.* %{buildroot}/%{_lib}/
ln -s ../../%{_lib}/libz.so.%{version} %{buildroot}%{_libdir}/

%if %{build_biarch}
install -d %{buildroot}/lib
mv %{buildroot}%{_prefix}/lib/*.so.* %{buildroot}/lib/
ln -s ../../lib/libz.so.%{version} %{buildroot}%{_prefix}/lib/
%endif

pushd contrib/minizip
%makeinstall_std
popd

rm -fr %{buildroot}%_libdir/libminizip.la

install -m644 objsdietlibc/libz.a -D %{buildroot}%{_prefix}/lib/dietlibc/lib-%{_arch}/libz.a

%clean
rm -fr %{buildroot}

%files -n %{lib_name}
%defattr(-, root, root)
%doc README
/%{_lib}/libz.so.%{lib_major}*
%{_libdir}/libz.so.%{lib_major}*
%if %{build_biarch}
/lib/libz.so.*
%{_prefix}/lib/libz.so.%{lib_major}*
%endif
%{_libdir}/libminizip.so.%{lib_major}*

%files -n %{lib_name}-devel
%defattr(-, root, root)
%doc README ChangeLog doc/algorithm.txt
%{_mandir}/man3/zlib.3*
%{_libdir}/*.a
%{_libdir}/*.so
%{_libdir}/pkgconfig/zlib.pc
%if %{build_biarch}
%{_prefix}/lib/*.a
%{_prefix}/lib/*.so
%{_prefix}/lib/pkgconfig/zlib.pc
%endif
%{_includedir}/*
%{_libdir}/pkgconfig/minizip.pc
%{_prefix}/lib/dietlibc/lib-%{_arch}/libz.a

%changelog
* Wed Jan 28 2015 bb <bb> 1.2.8-5pclos2015
- rebuild new glibc

* Tue May 20 2014 bb <bb> 1.2.8-4pclos2014
- build libz.a for drakinstaller binaries

* Mon May 19 2014 bb <bb> 1.2.8-3pclos2014
- rebuild against updates
